> This page is for Agent Handler.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.merge.dev/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.merge.dev/_mcp/server.

# Create custom regex rule (Tool Pack)

POST https://ah-api.merge.dev/api/v1/tool-packs/{tool_pack_id}/custom-regex-rules/
Content-Type: application/json

Create a custom regex rule for a tool pack. If name matches an org rule, creates an override.

Reference: https://docs.merge.dev/merge-agent-handler/agent-handler/custom-regex-rules/create-custom-regex-rule-tool-pack

## Authentication

- `Authorization` header (bearer token, required) — Token-based authentication with required prefix "Bearer"

## Request

### Path parameters

- `tool_pack_id` (string, required)

### Body (application/json)

This endpoint expects a CustomRegexOverrideCreateInput.

- `name` (string, required)
- `regex` (string, required)
- `score` (double, required)
- `context_keywords` (any, required)
- `is_active` (boolean, required)
- `inbound_action` (enum, required)
  - Allowed values: `BLOCK`, `REDACT`, `LOG`, `NONE`
- `outbound_action` (enum, required)
  - Allowed values: `BLOCK`, `REDACT`, `LOG`, `NONE`

## Response

### 201

- `id` (string, required)
- `name` (string, required)
- `regex` (string, required)
- `score` (double, required)
- `context_keywords` (any, required)
- `is_active` (boolean, required)
- `outbound_action` (string, required)
- `defined_at` (string, required)

## Examples

**Request**

```json
{
  "name": "string",
  "regex": "string",
  "score": 1.1,
  "is_active": true,
  "inbound_action": "BLOCK",
  "outbound_action": "BLOCK"
}
```

**Response**

```json
{
  "id": "string",
  "name": "string",
  "regex": "string",
  "score": 1.1,
  "is_active": true,
  "outbound_action": "string",
  "defined_at": "string"
}
```

**SDK Code**

```python
import requests

url = "https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/"

payload = {
    "name": "string",
    "regex": "string",
    "score": 1.1,
    "is_active": True,
    "inbound_action": "BLOCK",
    "outbound_action": "BLOCK"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"string","regex":"string","score":1.1,"is_active":true,"inbound_action":"BLOCK","outbound_action":"BLOCK"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/"

	payload := strings.NewReader("{\n  \"name\": \"string\",\n  \"regex\": \"string\",\n  \"score\": 1.1,\n  \"is_active\": true,\n  \"inbound_action\": \"BLOCK\",\n  \"outbound_action\": \"BLOCK\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"string\",\n  \"regex\": \"string\",\n  \"score\": 1.1,\n  \"is_active\": true,\n  \"inbound_action\": \"BLOCK\",\n  \"outbound_action\": \"BLOCK\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"string\",\n  \"regex\": \"string\",\n  \"score\": 1.1,\n  \"is_active\": true,\n  \"inbound_action\": \"BLOCK\",\n  \"outbound_action\": \"BLOCK\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/', [
  'body' => '{
  "name": "string",
  "regex": "string",
  "score": 1.1,
  "is_active": true,
  "inbound_action": "BLOCK",
  "outbound_action": "BLOCK"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"string\",\n  \"regex\": \"string\",\n  \"score\": 1.1,\n  \"is_active\": true,\n  \"inbound_action\": \"BLOCK\",\n  \"outbound_action\": \"BLOCK\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "string",
  "regex": "string",
  "score": 1.1,
  "is_active": true,
  "inbound_action": "BLOCK",
  "outbound_action": "BLOCK"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://ah-api.merge.dev/api/v1/tool-packs/tool_pack_id/custom-regex-rules/")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```